/*
  Code for extra routines.

  later to be integrated as methods within the library's class declarations
*/

#include "poly.H"
#include "extrapoly.H"
#include "automaton.H"

// #define DEBUG_RESIZE

// #define DEBUG_COPYCOL

int PrtMod;
vector **Exist_vectors;

// copy constructor
// removed 5/5 since wasted memory when copy was not intended in 
// poly.C and cherni.C
/*
void 
vector::operator=(const vector & vec) {
  int i;
  size = vec.size;
  p = (int *) malloc (size * sizeof(int));
  for (i=0;i<size;i++) {
    p[i] = vec.p[i];
  }
}
*/

// copy constructor, copy data too
vector::vector(const vector& vec) {
  int i;
  size = vec.size;
  p = new int[size];
  for (i=0;i<size;i++) {
    p[i]=vec.p[i];
  }
}


// return Gcd of entire matrix

int
matrix::gcd_of_frame_matrix() {
  // store Gcd's of all relevant integers in one large vector
  int *vec = (int *) malloc (sizeof(int) * nbrows*nbcolumns);
  int index = 0;
  int g;
  int i,j;

  // look at all points, i.e. [1 ..... b] for b != 0
  // find Gcd of all values, we can just ignore the value of b.
  // also, if in nplus1_form, ignore value of eps_pos variable
  for (i=0;i<nbrows-1;i++) {
    if ((p[i][0] == 1) &&  (p[i][nbcolumns-1] != 0)) {
      // ignore first and last columns
      for (j=1;j<nbcolumns-1;j++) {
	if (p[i][j] != 0) {
	  vec[index] = p[i][j];
	  index++;
	}
      }
    }
  }
  Vector_Gcd(vec,index,g);
  global_free(vec);
//  cout << "Returning gcd of " << g << " for frame matrix \n";
//  print();
//  cout << "done printing\n";
  return g;
}

// divide/multiply by the scalar
void
matrix::scale_frame_matrix(int scalar, int divide) {
  int i,j;

  // look at all points, i.e. [1 ..... b] for b != 0
  // find Gcd of all values, we can just ignore the value of b.
  // also, if in nplus1_form, ignore value of eps_pos variable
  for (i=0;i<nbrows-1;i++) {
    if ((p[i][0] == 1) &&  (p[i][nbcolumns-1] != 0)) {
      for (j=1;j<nbcolumns-1;j++) {
	if (p[i][j] != 0) {
	  if (divide) {
	    p[i][j] /= scalar;
	  }
	  else {
	    p[i][j] *= scalar;
	  }
	}
      }
    }
  }
}


// divide/multiply by the scalar
// all scaling is done on the constant term
void
matrix::scale_constr_matrix(int scalar, int divide) {

  int i;
  for (i=0;i<nbrows-1;i++) {
    if (divide) {
      p[i][nbcolumns-1] /= scalar;
    }
    else {
      p[i][nbcolumns-1] *= scalar;
    }
  }
}


// set all rows to 0's except for final row as 100001
void
matrix::blank() {
  int i,j;
  for (i=0;i<nbrows;i++) {
    for (j=0;j<nbcolumns;j++) {
      p[i][j] = 0;
    }
  }
  p[nbrows-1][0] = p[nbrows-1][nbcolumns-1] = 1;
}



int
varnr_2_indexnr( int varnr) {
// new library from 0 to nr_vars -1
// old library numbers from 1 to nrvars
  return(varnr+1);
}

// set the frame to be no longer available
// free the space it was using, if it was available
void
lib_polyhedron::invalidate_frame() {
  if (frame_available) {
    F.free();
    frame_available = false;
  }
}

void
lib_polyhedron::invalidate_constraints() {
  if (constraints_available) {
    C.free();
    constraints_available = false;
  }
}

// copy column from src var i2 to dest var i3
// old matrix is lost
lib_polyhedron *
lib_polyhedron::CopyColumn( int i2, int i3) {
// this was designed for the new library!
 // var numbering starts at 0, index by var not #
 // no range checking yet.
  int i;
  int src_pos = varnr_2_indexnr(i2);
  int dest_pos = varnr_2_indexnr(i3);
  int nr_cols = this->constraints()->nbcolumns;
  int nr_rows = this->constraints()->nbrows-1;  
				// nr_rows ignores the final 1 0 0 1 row.
				// store columns for Inequality[]
				// and Const[] separately

				// above 3 comment lines for new impl.
				// old one includes all rows

#ifdef DEBUG_COPYCOL
  cout << "src col = " << src_pos << " and dest pos = " << dest_pos << "\n";
#endif
  for (i=0;i<nr_rows;i++) {
#ifdef DEBUG_COPYCOL
    cout << "about to copy for row " << i << "\n";
#endif
    C.p[i][dest_pos] = C.p[i][src_pos];
  }
  // this operation destroys the validity of the generators
  invalidate_frame();
  return this;
}

// return a new poly.
// don't affect the old one
lib_polyhedron * 
AddAFreeVariable(lib_polyhedron *pp){

   int i, j, nbrows, nbcolumns;

   pp->constraints();
   if(pp->empty) return empty_lib_polyhedron(pp->constraints()->nbcolumns+1);
   pp->constraints();
   nbrows = pp->constraints()->nbrows;
   nbcolumns = pp->constraints()->nbcolumns;
   matrix m= matrix(nbrows,nbcolumns+1);
   for(i=0;i<nbrows;i++){
     // insert new var just before column for constant
     for(j=0;j<nbcolumns-1;j++) m.p[i][j]=pp->constraints()->p[i][j];
     j = nbcolumns-1; // explicitly assign it
     m.p[i][j]=0; m.p[i][j+1]=pp->constraints()->p[i][j];
   };
   /* don't need the added equation for null var */

   return new lib_polyhedron(m,true);
    
};


// *should* be returning a ptr to a NEW copy, without affecting the old one.
// currently destroys old copy if called for a nontrivial resize
// assume spoly is nonempty
lib_polyhedron *
Resize(lib_polyhedron *pp4, int newsize) {
 // var numbering starts at 0, index by var not #
 // no range checking yet.
 // only allow enlarging the size of the matrix
  int j;
  int nr_cols = pp4->constraints()->nbcolumns;
  int nr_rows = pp4->constraints()->nbrows;  
				// nr_rows ignores the final 1 0 0 1 row.
				// store columns for Inequality[]
				// and Const[] separately

				// above 3 comment lines for new impl.
				// old one includes all rows


  polyedre *pp = pp4;
#ifdef DEBUG_RESIZE
    cout << "within resize() here is *pp4 \n" << flush;
    pp4->print(); fflush(stdout);
    cout << "Nr cols = " << nr_cols << ", Newsize = " << newsize << "\n";
#endif    
    if (nr_cols > newsize) {
	cout << "Error: size is now " << nr_cols << " cannot make it " <<
		newsize << "\n" ;
    }
  else  {
    if (newsize == nr_cols) {
      return ( pp->copy()); 
    }
    else {
      // newsize > nr_cols
      pp->constraints();
      for (j =0;j<newsize-nr_cols;j++) {
//	pp = pp->add_a_null_variable();
	lib_polyhedron *tempp = pp;
	pp = AddAFreeVariable(pp);
	tempp->free();
#ifdef DEBUG_RESIZE
if (debug_magic_nr == 24) {
        cout << "added one variable\n";
	cout << "number cols is now " << pp->constraints()->nbcolumns << "\n";
        cout << flush;
        pp->print(); fflush(stdout);

}
#endif
      }
//      pp->constraints()->p[nr_rows][nr_cols-1] = 0;
//      pp->constraints()->p[nr_rows][newsize-1] = 1;
    }
  }

    return(pp);

}






// copies over variables.
// assumes the constraints are available.
// old poly is lost, written over 
lib_polyhedron *
lib_polyhedron::copy_extra_to_old(int nr_keep_cols, int nr_copy_cols, 
	int *index_p) {
 // var numbering starts at 0, index by var not #
 // no range checking yet.
 // copy columns from index_p to original
  int j;
  // force the constraints to be formed correctly.
  matrix *cmp = constraints();
  int nr_cols = C.nbcolumns;
  int nr_rows = C.nbrows;  
				// nr_rows ignores the final 1 0 0 1 row.
				// store columns for Inequality[]
				// and Const[] separately

				// above 3 comment lines for new impl.
				// old one includes all rows


    if (nr_cols != nr_keep_cols + nr_copy_cols) {
	cout << "Error: sizes wrong" << nr_cols << "\n" ;
    }
    else {
      for (j =0;j<nr_copy_cols;j++) {
	/* column numbers to keep incl equality and const at ends */
        /* copy column() takes col numbers starting at 1 */
	// arg refer to vars not to column, starting at 0 for 1st var.
	// first arg is source, second is dest.


	CopyColumn(nr_keep_cols-2+j,index_p[j]-1);
      }
    }
    return(this);
}





lib_polyhedron *
delete_cols(lib_polyhedron *pp4, int nr_orig_cols, int nr_del_vars) {
 // var numbering starts at 0, index by var not #
 // no range checking yet.
 // delete columns using library routine that does existential quant first
 // on deleted variables.
  int j;
  int nr_cols = pp4->constraints()->nbcolumns;
  int nr_rows = pp4->constraints()->nbrows;  
				// nr_rows ignores the final 1 0 0 1 row.
				// store columns for Inequality[]
				// and Const[] separately

				// above 3 comment lines for new impl.
				// old one includes all rows


  polyedre *pp = pp4;
    
    if (nr_cols != nr_orig_cols + nr_del_vars) {
	cout << "Error: sizes wrong " << nr_cols << "\n" ;
    }
    else {

      for (j =0;j<nr_del_vars;j++) {
	/* column numbers to keep incl equality and const at ends */
        /* suppress column() takes variable numbers starting at 1 */
	lib_polyhedron *tempp = pp;
	pp = pp->SuppressColumn(varnr_2_indexnr(nr_orig_cols-2+j));
	tempp->free();
      }
    }
    return(pp);

}


// return a new object. old one is kept intact. 
lib_polyhedron *
lib_polyhedron::vaporize_variables( int nr_vars) {
//
// vaporize the columns corresponding to the last nr_vars variables. 
// i.e. delete columns, without regard to values in it, i.e. no exist. quant.
// assume the matrix currently stored as a constraint matrix
//                                         **********

  int nr_cols = C.nbcolumns;
  int nr_rows = C.nbrows;  

  int nr_keep_cols = C.nbcolumns-nr_vars;
  int i,j;
  constraints();
  if(nr_vars<0 || nr_vars>nr_cols-2){
     printf("Error: try to delete a number of variables out of the domain\n");
     exit(2);
  };
  matrix m = matrix(nr_rows,nr_keep_cols); 
  for(i=0;i<nr_rows;i++){
    for(j=0;j<nr_keep_cols-1;j++) m.p[i][j]=C.p[i][j];
    // copy last column for const
     m.p[i][nr_keep_cols-1]=C.p[i][nr_cols-1];
  };
   return new lib_polyhedron(m,true);  // return in constraint matrix form
};

// takes hull, leaving *pp intact
// but object destroyed. returns pointer to new object for hull.
// beware: old version of hull(frame) uses the frame if object is empty,
// and doesn't otherwise! therefore only call it if object is nonempty
lib_polyhedron *
lib_polyhedron::hull(lib_polyhedron *pp) {
  lib_polyhedron *tempp;
  if (empty) {
    if (pp->empty) {
      return (this );
    }
    else {
      delete this;
      tempp = new lib_polyhedron(*(pp->frame()->copy()), false);
      return tempp;
    }
  }
  // both non empty.
  return (hull(*(pp->frame())));
}






int vector_size;
 
// max_ass_vars is max number of vars ever reassigned.
// so we have a 2D array of vectors, since the addition of the element
// depends on the size of the *extended* ass array.
// 9/7/95:
// first dimension is number of extra vars, second is var to existentially
//      quantify
// was previously one short on number of extra vars
void
make_exist_vectors(int nr_vars, int max_ass_vars) {
  int i,j; 
  int nr_ex;   // nr of extra variables being assigned (nr extended vars)
  vector_size = nr_vars+2;
 // for now we assume there may be as many as nv_vars in some assignment
// it is safe (extended). i.e. ignore max_ass_vars, since memory is not that
// tight!
  int ignore = max_ass_vars;  // deliberately ignore for now.

  Exist_vectors = (vector **) malloc((nr_vars+1) * sizeof(vector *));
  for (i=0;i<nr_vars+1;i++) {
    Exist_vectors[i] = (vector *) malloc (nr_vars * sizeof(vector));
  }

  for (nr_ex = 0; nr_ex < nr_vars+1; nr_ex++) {
    for (i=0;i<nr_vars;i++) {
      // compiler doesn't like this
      //    Exist_vectors[i] = vector(nr_vars+2);
      Exist_vectors[nr_ex][i].size = nr_vars+2+nr_ex;
      Exist_vectors[nr_ex][i].p = 
	(int *) malloc ((nr_vars+2+nr_ex) * sizeof(int));
//       Exist_vectors[nr_ex][i].p[0] = 1;
      for (j=0;j<nr_vars+2+nr_ex;j++) {
	Exist_vectors[nr_ex][i].p[j] = 0;
      }
      // position shifted one by initial col.
      Exist_vectors[nr_ex][i].p[1+i] = 1;
//      Exist_vectors[nr_ex][i].print();
    }
  }

}

vector *
exist_vector(int v_nr, int nr_extra_vars) {
// note: second var has v_nr = 2 i.e. number from 1.
#ifdef DEBUG_EXIST_VECTORS
  cout << "call to get exist vector for params " << v_nr << " and " <<
    nr_extra_vars << "\n" << flush;
  cout << "vector is :    ";
  Exist_vectors[nr_extra_vars][v_nr-1].print();
#endif
  return(&(Exist_vectors[nr_extra_vars][v_nr-1]));
}

// destroys the original
//     since calls to AddElt destroy the original
lib_polyhedron *
lib_polyhedron::existent(int v_nr, int nr_extra_vars) {
  AddElt(exist_vector(v_nr, nr_extra_vars));
  return this;
}


// existentially quantify nr_exist_vars vars, found in indices
// good for eliminating variables in result of a computation.
// destroys old poly.
lib_polyhedron *
lib_polyhedron::existent(int  nr_exist_vars, int *indices) {
  int i;
  for (i=0;i<nr_exist_vars;i++) {
    // vars start at 0, but indices to exist_vector at 1.
    // destroys (frees) old poly in the process
    this->AddElt(exist_vector(indices[i]+1, 0));
  }
  return this;
}


// return fresh copy of poly. with
// added constraint from row rownr of matrix
// M.  Use negated constraint iff 
// negated = true
lib_polyhedron *
lib_polyhedron::add_row(matrix *mp, int rownr, bool negated) {
  int i,j;
  matrix new_C;
  lib_polyhedron *result;
  matrix  * cmp = constraints();
  int num_rows = cmp->nbrows+1;
  int num_cols = cmp->nbcolumns;
//  cout << "Constraint matrix = \n";
//  cmp->print(); cmp->ptprint();
  new_C = matrix(num_rows,num_cols);
  // copy all non-final rows of original poly
  for (i=0;i<num_rows-2;i++) {
    for (j=0;j<num_cols;j++) {
      new_C.p[i][j] = cmp->p[i][j];
    }
  }
  // add the inverted row of region * rp, assumed to be an inequality.
  new_C.p[num_rows-2][0] = 1;
  for (j=1;j<num_cols;j++) {
    if (negated) {
      new_C.p[num_rows-2][j] = -mp->p[rownr][j];
    }
    else {
      new_C.p[num_rows-2][j] = mp->p[rownr][j];
    }
  }
  // add the final row
  new_C.p[num_rows-1][0] = new_C.p[num_rows-1][num_cols-1] = 1;
  for (j=1;j<num_cols-1;j++) {
    new_C.p[num_rows-1][j] = 0;
  }

  // form the poly. from new_C's constraints
  result = new lib_polyhedron(new_C,true) ;
  return(result);
}


/* === for printing ======== */

bool
is_lhs(int side) {
  return( (side == 0) );
}

// side = 0 for lhs, 1 for RHS. 
void
output_term(int varpos, int matrix_val, char **varnames, bool use_leq, 
	    int side, bool *first_term_p) {
  if ( ( (varpos == var_count+1) && ((*first_term_p)|| (matrix_val!=0)))
                                 // the constant (above)
    || ( (matrix_val > 0) && ((!use_leq && is_lhs(side)) || 
                              (use_leq && !is_lhs(side))))
    || ( (matrix_val < 0) && ((!use_leq &&!is_lhs(side)) || 
                              (use_leq &&  is_lhs(side))))) {
    // since vars start at 0 in varnames
    if  (varpos != var_count+1) {
      // a real variable

      if  (! *first_term_p)  { 
	cout << " + ";
      }
      // or else the leading 1 is redundant
      if (abs_val(matrix_val) != 1 ) { 
	cout << abs_val(matrix_val);
      }
      *first_term_p = false;
      // output the varname if this is not for the constant
      cout << varnames[varpos-1];
    }
    else {
      // constant 
      // possibly add a 0 at end, if no other terms on this side
	
      if ( 	  ((matrix_val > 0) && use_leq && !is_lhs(side))
	       || ((matrix_val > 0) && !use_leq && is_lhs(side))
               || ((matrix_val < 0)&& use_leq && is_lhs(side))
               || ((matrix_val < 0)&& !use_leq && !is_lhs(side))

               )  {
	if  (! *first_term_p)  { 
	  cout << " + ";
	}
	cout << abs_val(matrix_val);
      }
      else {
	if (*first_term_p) {  
	  // i..e no vars on this side, so print 0
	  cout << "0";
	}
      }
      *first_term_p = false;
    }
  }
}


// determine whether all var coeffs have same sign.
// return signstatus to 0 if not, -1 if all neg, and 1 if all positive
// param is ptr to the row.  use global var varcount for # of variables
int
signstatus(int *row) {
  bool foundneg = false;
  bool foundpos = false;
  int i;
  for (i=0;i<var_count;i++) {
    foundpos = foundpos || (row[i+1]>0);
    foundneg = foundneg || (row[i+1]<0);
  }
  if (foundpos && ! foundneg) {
    return ( 1 );
  }
  else {
    if (foundneg && !foundpos) {
      return(-1);
    }
    else {
      return(0);
    }
  }
}
    

// pretty print a single row r, with form NFORm or NPLUS1_FORM
void
matrix::ptprintrow(int r,  char **vnames, bool *non_trivial_p, int form, 
		   ostream& outf) {
// determine whether the equality   is <= or >=, depending on what's required
//    for a positive constant on the right hand side.
// then put all other variables so that their coefficients are positive
// create no output if the constraint is the trivial constraint 1 00000 1
  // figure out whether row is non-trivial
// 4/28/95. augmenting algorithm to deal with ">= x" appearing as a constraint
//          must check whether all vars have neg const.
// if all variable coeffs have same sign, put all on LHS.
// easier to do the implementataion with a majority decision. put most on LHS.
//        then check whether RHS is empty.
  int i;
  bool was_non_trivial = *non_trivial_p;
  int eps_pos;

  if (form == NPLUS1_FORM) {
    // check if it's a constraint on eps
    eps_pos = var_index("eps_slack");  
    bool eps_constraint = true;
    for (i=1;i<var_count+1;i++) {
      if ((i!=eps_pos) && (p[r][i] != 0)) {
        eps_constraint = false;
      }
    }
    if (eps_constraint) {
      *non_trivial_p = false;
      return ;
    }
  }

  *non_trivial_p = false;
  for (i=1;i<var_count+1;i++) {
    if (p[r][i] != 0) {
      *non_trivial_p = true;
    }
  }
  if (*non_trivial_p) {
    bool use_leq;  // whether to use leq (<=) constraint as opposed to >=
    bool use_eq;   // whether it may be an equality?
                   // in which case, still use the LEQ info for putting vars
                   // on correct side of equation.
    bool strict;   // whether inequality is strict
    int coeffsignstatus = signstatus(p[r]); 
    bool first_term = true;
    use_leq = (p[r][var_count+1] >= 0) && (coeffsignstatus != 1);
    use_eq = (p[r][0] == 0);
    if (was_non_trivial) {
      outf << "   & ";
    }
    else {
      outf << "     ";
    }
    strict = (p[r][var_count] != 0); // the coeff for eps-slack
    // print lhs, use 0 for side param in output_term
    for (i=1;i<var_count+1;i++) {
      if (p[r][i] != 0) {
	if ((form == NFORM) || (i != eps_pos))
    	  output_term(i,p[r][i],vnames,use_leq,0,&first_term);
      }
    }
    // the constant
    output_term(var_count+1,p[r][var_count+1],vnames,use_leq,0,&first_term);
    first_term = true;

    if (use_eq) {
      outf << " = ";
    }
    else {
      if (use_leq) {
	if (strict) {
  	  outf << " < ";
	}
	else {
	  outf << " <= ";
	}
      }
      else {
	if (strict) {
	  outf << " > ";
	}
	else {
	  outf << " >= ";
	}
      }
    }

    // print rhs
    // use 1 for side
    // do all vars
    for (i=1;i<var_count+1;i++) {
      if (p[r][i] != 0) { // for vars
	if ((form == NFORM) || (i != eps_pos))
	  output_term(i,p[r][i],vnames,use_leq,1,&first_term);
      }
    }
    // the constant
    output_term(var_count+1,p[r][var_count+1],vnames,use_leq,1,&first_term);
  }
}


// pretty print the (assumed constraint) matrix using names in varnames
// global var var_count determines number of variables.
void
matrix::pretty_print(char **vnames, int form, ostream& outf) {
// use really simple algorithm for now.
// later print as <= if vars have only negative coefficients.
//                x >= y + 1  if mixed
  int r; // for rows
  bool non_trivial_row = false;  // whether the row is NOT 1 00000 1
  bool matrix_non_trivial = false;


  // if using vertical mode (1) need to push all lines over 3 spaces
  if (format_mode == 1)
    outf << "   ";
  // omit last row that's 100001
  for (r=0;r<nbrows-1;r++) {
    ptprintrow(r,vnames,&non_trivial_row,form);
    if ((format_mode ==1) && (r<nbrows-1) && non_trivial_row) {
      outf << "\n";
    }
    matrix_non_trivial = matrix_non_trivial || non_trivial_row;
    // to tell ptprintrow that there have been previous nontrivial rows printed
    non_trivial_row = matrix_non_trivial; 
                        
  }
  if (!matrix_non_trivial) {
    outf << "True\n";
  }
  else {
    if (format_mode == 0) {
      outf << "\n";
    }
  }
}

// form = NPLUS1_FORM or N_FORM
void
matrix::ptprint( int form, ostream& outf) {
  pretty_print(varnames, form, outf);
}



void lib_polyhedron::ptprint(ostream& outf) {
   if (empty) outf << "False\n"; 
   else {
     (this->constraints())->ptprint(NFORM, outf);
   }
}; /* lib_polyhedron::pretty_print */

/* new routines for checking whether a frame matrix is OK for addition of */
/* generators */
/* this test must be done before adding generating rays to a region */
/* OK scenarios */
/* 1) bounded. add rays for each frame pt */
/* 2) a cone, i.e. frame representation is only rays. add each ray */
/* 3) includes the origin (plus other pts), add all pts and rays as rays */
/* 4) if cone through the pts contains all the rays, just */
/*      add rays for all the pts */
/* if any of the above conditions are satisfied, it suffices to merely add */
/*    all elts of the frame as rays */
/* input is a frame in matrix representation */
bool
ok_to_generate(matrix *fr) {
  int i,j;
  bool OK;
  matrix pt_cone;
  matrix gen_cone;
  int pt_rows, gen_rows;
  int nrows = fr->nbrows;
  int ncols = fr->nbcolumns;
  int nr_pts = 0;
  for (i=0;i<nrows-1;i++) {
    if ((fr->p[i][0] == 1) && (fr->p[i][ncols-1] != 0)) {
      nr_pts++;
    }
  }
  if ((nr_pts == nrows-1) || (nr_pts ==0)) {
    // then all pts        OR all generators
    return(true);
  }
  // need to add a row for the origin as a pt
  pt_cone = matrix(nr_pts+1+1,ncols);
  gen_cone = matrix(nrows-nr_pts+1,ncols);
  pt_rows = 0;
  gen_rows = 0;

  for (i=0;i<nrows-1;i++) {
    // test if pt or not
    if ((fr->p[i][0] == 1) && (fr->p[i][ncols-1] != 0)) {
      // have a pt
      bool is_origin = true;
      // copy the data pt, not the ends values of row
      for (j=1;j<ncols-1;j++) {
	pt_cone.p[pt_rows][j] = fr->p[i][j];
	if (fr->p[i][j]) {
	  is_origin = false;
	}
      }
      if (is_origin) {
	pt_cone.free();
	return(true);
      }
      // make the vertex into a ray
      pt_cone.p[pt_rows][0] = 1;
      pt_cone.p[pt_rows][ncols-1] = 0;
      pt_rows++;
    }
    else {
      // some kind of generator, i.e. ray or line
      for (j=0;j<ncols;j++) {
	gen_cone.p[gen_rows][j] = fr->p[i][j];
      }
      gen_rows++;
    }
  }

    
  if (gen_rows != nrows-nr_pts -1) {
    cerr << "some accounting error\n";
  }
  if (pt_rows != nr_pts) {
    cerr << "some accounting error\n";
  }

  // add the final rows to both cone matrices
  // one for final 10001 and one identical for the origin pt
  for (j=0;j<ncols;j++) {
    pt_cone.p[nr_pts][j] = pt_cone.p[nr_pts+1][j] = 0;
    gen_cone.p[nrows-nr_pts-1][j] = gen_cone.p[nrows-nr_pts][j] = 0;
  }
  pt_cone.p[nr_pts][0] = pt_cone.p[nr_pts][ncols-1] =
      pt_cone.p[nr_pts+1][0] = pt_cone.p[nr_pts+1][ncols-1] = 1;
  gen_cone.p[nrows-nr_pts-1][0] = gen_cone.p[nrows-nr_pts-1][ncols-1] = 1;
    gen_cone.p[nrows-nr_pts][0] = gen_cone.p[nrows-nr_pts][ncols-1] = 1;

  lib_polyhedron  pt_poly = lib_polyhedron(pt_cone,false);
  lib_polyhedron gen_poly = lib_polyhedron(gen_cone,false);

  OK = (gen_poly <= pt_poly);
  return(OK);
}


void
lib_polyhedron::frame_print() {
  matrix *fr = frame();
  fr->print();
}

void
matrix::set_last_row() {
  int j;
  for (j=1;j<nbcolumns-1;j++) {
    p[nbrows-1][j] = 0;
  }
  p[nbrows-1][0] =   p[nbrows-1][nbcolumns-1] = 1;
}


bool
matrix::is_strict() {
  int i;
  for (i=0;i<nbrows-1;i++) {
    if (p[i][0] == 2 ) {
      return true;
    }
  }
  return false;
}


// whether an nplus1 form is uses strict inequalities or not.
//  this is a quick test, it's OK to be conservative, i.e. return strict
//  when it's really nonstrict, since the  routines that assume it's strict
//  always also work for nonstrict matrices (just more slowly).
// assume the nplus1 form has the eps in col with index k.
// 
// assume object is NON-EMPTY
bool 
matrix::nplus1_is_strict(int k) {
  // search for a row with nonzero entry for eps_slack column, 
  // and a nonzero entry in the col for some other variable
  int i,j;
  for (i=0;i<nbrows-1;i++) {
    if (p[i][k]!=0) {
      for (j=1;j<nbcolumns-1;j++) {
	if ((p[i][j] != 0) && (j!=k)) {
// cout << "strict matrix\n";
// print();
// ptprint(NPLUS1_FORM);
	  return true;
	}
      }
    }
  }
  return false;

}



// whether an nplus1 form is use the slack variable at all
// in which case it is definitely not a strict (nonempty) poly
// yields true only if nonstrict or possibly empty
//
// assume the nplus1 form has the eps in col with index k.
// 
// assume object is NON-EMPTY
bool 
matrix::nplus1_def_nonstrict(int k) {
  // search for a row with nonzero entry for eps_slack column, 
  // and a nonzero entry in the col for some other variable
  int i;
  for (i=0;i<nbrows-1;i++) {
    if (p[i][k]!=0) {
      return false;
    }
  }
  return true;
}



bool
matrix::eps_present(int eps_pos) {
  int i;
  for (i=0;i<nbrows-2;i++) {
    if (p[i][eps_pos]) {
      return true;
    }
  }
  return false;
}

int 
lib_polyhedron::dim() {
  return dimension;
}


